=== debian/changelog ===
mame (0.182-1) unstable; urgency=medium

  * New upstream release.
  * Add kfreebsd_dirent.h_path.patch to fix dirent.h include path for
    kFreeBSD builds (thanks Steven Chamberlain; closes: #852507).
  * Drop ConvertUTF.* from the tarball as it is under the Unicode
    non-free license.
  * Add avoid_linenoise.patch: define NO_USE_LINENOISE and guard uses of
    linenoise code with it, to avoid the need to compile 3rdparty/linenoise.

 -- Jordi Mallach <jordi@debian.org>  Thu, 26 Jan 2017 01:56:43 +0100

mame (0.181-1) unstable; urgency=medium

  * New upstream release.
  * Bump debhelper compat to v10.
  * Refresh patches.

 -- Jordi Mallach <jordi@debian.org>  Wed, 28 Dec 2016 13:01:35 +0100

mame (0.180-1) unstable; urgency=medium

  * New upstream release
  [ Cesare Falco ]
  * Refresh patches.

  [ Jordi Mallach ]
  * Switch back to GCC6 for arm64, as the compiler regression is now fixed.

 -- Jordi Mallach <jordi@debian.org>  Wed, 14 Dec 2016 12:37:35 +0100

mame (0.179-2) unstable; urgency=medium

  * Add -fPIC to arm64 ARCHOPTS to workaround yet another build issue.
  * Add m68000_archopts.patch: Add $(ARCHOPTS) to compiler invocation in the
    standalone m68000 makefile.

 -- Jordi Mallach <jordi@debian.org>  Fri, 04 Nov 2016 11:15:21 +0100

mame (0.179-1) unstable; urgency=medium

  * New upstream release.
  * hurd.patch: use the correct include for pthread_safe().
  * Build-Depend on and set CC/CXX to gcc-5/g++-5 on arm64, to workaround
    a GCC 6 bug that causes MAME to FTBFS (closes: #840468).
  * Demote libjs-sphinxdoc and libjs-mathjax to Suggests, as the docs are
    still readable without those installed.
  * Remove testkeys and add floptool to mame-tools' description.

 -- Jordi Mallach <jordi@debian.org>  Thu, 27 Oct 2016 10:30:19 +0200

mame (0.178-1) unstable; urgency=medium

  * New upstream release.
  * Add Build-Depends-Indep on python3-sphinx.
  * Build the singlehtml flavour of docs.
  * Add a new binary package mame-doc and move all the (generated) docs
    to this package.
  * Let mame suggest mame-doc.
  * Exclude the install of jquery.js and underscore.js, and instead
    depend and symlink to the packaged versions.
  * Add sphinx_mathjax_location.patch: point at the local filesystem
    path of the mathjax javascript, to avoid a privacy breach when opening
    the docs in a browser.
  * Add Depends on libjs-sphinxdoc and libjs-mathjax.
  * Register the html docs with doc-base.
  * Remove obsolete reference to MESS in mame-tools' description.
  * Add missing patch headers.

 -- Jordi Mallach <jordi@debian.org>  Thu, 29 Sep 2016 02:40:06 +0200

mame (0.177-1) unstable; urgency=medium

  * New upstream release.
  * Drop x32.patch, merged upstream.
  * Adapt packaging to massive upstream docs rewrite.
  * Install whatsnew.txt as upstream changelog.
  * Enable all hardening options.
  * Add the non-minified version of modernizr.js to d/missing-sources,
    taken from the modernizr-2.6.2+ds1-1 Debian source package.

 -- Jordi Mallach <jordi@debian.org>  Tue, 27 Sep 2016 18:15:28 +0200

mame (0.176-3) unstable; urgency=medium

  * Drop Build-Depends on subversion, nothing uses it these days, and it
    was actually only necessary for get-orig-source target.
  * Add x32.patch: fix incorrect detection of 64 bit architecture in
    rapidjson, adding a check for __x86_64__ && __ILP32__, to fix a
    build error on x32.

 -- Jordi Mallach <jordi@debian.org>  Thu, 18 Aug 2016 18:13:13 +0200

mame (0.176-2) unstable; urgency=medium

  * Brown paper bag time: fix perms for /etc/mame contents in
    override_dh_fixperms-arch, to fix arch:all builds.

 -- Jordi Mallach <jordi@debian.org>  Thu, 28 Jul 2016 08:45:37 +0200

mame (0.176-1) unstable; urgency=medium

  [ Jordi Mallach ]
  * New upstream release.
    - Includes Steven Chamberlain's kfreebsd fixes for several build errors
      on kfreebsd-*. Many thanks! (closes: #830974)
    - Includes fixes for ppc64el builds (closes: #825483).
  * Install bgfx, language, plugins and uismall.bdf files in mame-data.
    Thanks to Vas Crabb for pointing this out.
  * Add a override_dh_auto_test that just runs "mame -valid" after the build.
    For now, make it non-fatal.
  * Add some additional docs to the mame binary.
  * Use system libuv.
  * Install default plugin.ini and ui.ini files as examples.
  * Add an empty override_dh_auto_build-indep rule, so arch-independent
    don't actually build the whole thing. Also rename dh_auto_test to
    their -arch variants.
  * Add libutil-freebsd-dev to Build-Depends for kfreebsd-any.
  * Add hurd.patch with some fixes to the build on hurd-i386 systems.
  * Add a makefile hack to allow building on a "gnu" platform with genie.
  * Drop remove-m64_flag_for_mips64el_alpha.patch, merged upstream.
  * Make mame build verbosely by default, without entangling it to DH_VERBOSE.
  * Remove generated doxygen docs for a 3rdparty module from source (lintian).
  * Prune more generated binaries from the source tarball (lintian).
  * Remove unused lintian overrides.

  [ Cesare Falco ]
  * Improved get-orig-source target
  * Updated mame.ini files to most recent *path entries
  * Install samples and additional .ini files as well

 -- Jordi Mallach <jordi@debian.org>  Thu, 28 Jul 2016 07:28:07 +0200
