=== debian/watch ===
version=3
https://github.com/mamedev/mame/tags/ .+(\d)(\d{3})\.tar\.gz
